#include <iostream>

using namespace std;

int main()
{
    int n;
    int m;
    cin>>n>>m;
    long long doha[n][m];
    long long doha2[n][m];
    for(int i=0;i<n;i++)
    {
     for(int j=0;j<m;j++)
     {
        cin>>doha[i][j];
     }
    }
    int brs;
    cin>>brs;
    int xiyi;
    for(int a=0;a<brs;a++)
    {
        int xi,yi;
        cin>>xi>>yi;
        xiyi=doha[xi-1][yi-1];
        doha[xi-1][yi-1]=10000000000;
        doha2[0][0]=doha[0][0];
    for(int i=1;i<n;i++)
    {
        doha2[i][0]=doha[i][0]+doha2[i-1][0];
    }
    for(int j=1;j<m;j++)
    {
        doha2[0][j]=doha[0][j]+doha2[0][j-1];
    }
        for(int i=1;i<n;i++)
        {
            for(int j=1;j<m;j++)
            {
                doha2[i][j]= min(doha2[i][j-1],doha2[i-1][j])+doha[i][j];
            }
        }

        cout<<doha2[n-1][m-1] << endl ;
        doha[xi-1][yi-1]=xiyi;
    }
    return 0;
}